#import "YeolClockController.h"

@implementation YeolClockController

- (void)alarmOff
{
		[alarmStatus setStringValue:@"Off"];
		alarmOn=NO;
		[alarmTimeHour setEditable:YES];
		[alarmTimeMinute setEditable:YES];
		[alarmTimeAMPM setEditable:YES];
		[alarmTimeHour setSelectable:YES];
		[alarmTimeMinute setSelectable:YES];
		[alarmTimeAMPM setSelectable:YES];
}

- (void)alarmOn
{
	[alarmStatus setStringValue:@"On"];
		alarmOn=YES;
		[alarmTimeHour setEditable:NO];
		[alarmTimeMinute setEditable:NO];
		[alarmTimeAMPM setEditable:NO];
		[alarmTimeHour setSelectable:NO];
		[alarmTimeMinute setSelectable:NO];
		[alarmTimeAMPM setSelectable:NO];
		int hourVal = ([alarmTimeHour intValue]-1)%12+1;
		int minVal = [alarmTimeMinute intValue]%60;
		NSString *hour;
		NSString *minute;
		if (hourVal>9) {
			hour = [NSString stringWithFormat:@"%d", hourVal];
		} else {
			hour = [NSString stringWithFormat:@"0%d", hourVal];
		}
		if (minVal>9) {
			minute =[NSString stringWithFormat:@"%d", minVal];
		} else {
			minute =[NSString stringWithFormat:@"0%d", minVal];
		}
		NSString *ampm =[alarmTimeAMPM stringValue];
		if ([ampm isEqual:@"p"]) {
			ampm = @"PM";
		}
		if ([ampm isEqual:@"P"]) {
			ampm = @"PM";
		}
		if (![ampm isEqual:@"PM"]) {
			ampm =@"AM";
		}
		[alarmTime release];
		alarmTime=[[NSString stringWithFormat:@"%@:%@ %@", hour, minute, ampm] retain];
		NSLog(alarmTime);
}

- (IBAction)toggleAlarm:(id)sender
{
	if (alarmOn){
		[self alarmOff];
	}else{
		[self alarmOn];
	}
}

- (IBAction)sleepAlarm:(id)sender
{
	[movieView stop:self];
	int minVal = ([alarmTimeMinute intValue]+10)%60;
	[alarmTimeMinute setFloatValue:minVal];
	
	[self alarmOn];
}

- (id)init
{
	if (self = [super init]){
		controlTimer = [NSTimer scheduledTimerWithTimeInterval:0.01 target:self selector:@selector(update:) userInfo:nil repeats:YES];
		alarmOn=NO;
		alarmTime=[[NSString stringWithFormat:@"00:00 0M"] retain];
		///Populate the list
		NSFileManager *fileManager = [NSFileManager defaultManager];
		path=[[@"~/Music/YeolClock" stringByExpandingTildeInPath] retain];
		files = [[fileManager directoryContentsAtPath:path] retain];
		movieView = [[NSMovieView alloc] init];
		[movieView setLoopMode:NSQTMovieLoopingPlayback];
		[movieView setVolume:1.0];
	}
	return self;
}

- (int)numberOfItemsInComboBox:(NSComboBox *)aComboBox {
    return [files count];
}
- (id)comboBox:(NSComboBox *)aComboBox objectValueForItemAtIndex:(int)index {
    return [files objectAtIndex:index];
}
- (unsigned int)comboBox:(NSComboBox *)aComboBox indexOfItemWithStringValue:(NSString *)string {
    return [files indexOfObject: string];
}


-(void)update:(NSTimer *)theTimer
{
		NSDate *currentDate=[NSDate date];
		NSString *theTime = [currentDate descriptionWithCalendarFormat:@"%I:%M:%S %p" timeZone:nil locale:nil];
		[currentTime setStringValue:theTime];
		NSString *compareTime = [currentDate descriptionWithCalendarFormat:@"%I:%M %p" timeZone:nil locale:nil];
		if (([compareTime isEqual:alarmTime]) && (alarmOn)) {
			NSLog(@"BEEP!");
			NSString *file = [files objectAtIndex:[songPicker indexOfSelectedItem]];
			NSString *fullpath = [path stringByAppendingPathComponent:file];
			NSLog(fullpath);
			NSURL *theURL = [NSURL fileURLWithPath:fullpath];
			NSMovie *theMovie = [[[NSMovie alloc] initWithURL:theURL byReference:NO] autorelease];
			[movieView setMovie:theMovie];
			[movieView start:self];
			[self alarmOff];
		}
}

-(void)dealloc
{	
	[movieView release];
	[files release];
	[alarmTime release];
	[controlTimer invalidate];
	[super dealloc];
}

@end
